<?php
function mostraMessaggio(){
	if (isset($_SESSION["messaggio"])){
		echo $_SESSION["messaggio"];
        unset($_SESSION["messaggio"]);
    }
}

function pulisciStringa($stringa){
	global $connessione;
	$stringa = strip_tags($stringa);
	$stringa = mysqli_real_escape_string($connessione,$stringa);
	$stringa = trim($stringa);
	return $stringa;
}

function checkCampi($input, $nomeCampo){
   if (!isset($input) || empty($input)) {
      $_SESSION["messaggio"] = "Il campo {$nomeCampo} deve essere riempito.";
      return false;
   }
   return true;
}

function activeMenu($requestUri){
    $current_file_name = basename($_SERVER['REQUEST_URI'], ".php");

    if ($current_file_name == $requestUri)
        return true;
	
	return false;
}

function token($length = 32) {
	$string = 'ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789';
	
	$token = '';
	
	for ($i = 0; $i < $length; $i++) {
		$token .= $string[mt_rand(0, strlen($string) - 1)];
	}	
	
	return $token;
}

function getCategories($parent_id = 0) {
	if (!$category_data) {
		$category_data = array();
		
		$query = mysqli_query($connessione,"SELECT * FROM categorie WHERE id_parent = '" . (int)$parent_id . "' ORDER BY sort_order, nome ASC") or die(mysqli_error());
		
		while($result = mysqli_fetch_array($query)){
			$category_data[] = array(
				'id_categoria' => $result['id_categoria'],
				'nome'  => getPath($result['id_categoria']),
				'stato'        => $result['stato'],
				'sort_order'        => $result['sort_order']
			);
			
			$category_data = array_merge($category_data, getCategories($result['id_categoria']));
		}	
	}	
	return $category_data;
}
	
function getPath($categoria_id) {
	$query = mysqli_query($connessione,"SELECT nome, id_parent FROM categorie WHERE id_categoria = '" . (int)$categoria_id . "'") or die(mysqli_error());
		
	$row = mysqli_fetch_array($query);
	if ($row['id_parent']) {
		return getPath($row['id_parent']) . ' -> ' . $row['nome'];
	} else {
		return $row['nome'];
	}
}

function formatSizeUnits($bytes){
        if ($bytes >= 1073741824)
        {
            $bytes = number_format($bytes / 1073741824, 2) . ' GB';
        }
        elseif ($bytes >= 1048576)
        {
            $bytes = number_format($bytes / 1048576, 2) . ' MB';
        }
        elseif ($bytes >= 1024)
        {
            $bytes = number_format($bytes / 1024, 2) . ' kB';
        }
        elseif ($bytes > 1)
        {
            $bytes = $bytes . ' bytes';
        }
        elseif ($bytes == 1)
        {
            $bytes = $bytes . ' byte';
        }
        else
        {
            $bytes = '0 bytes';
        }

        return $bytes;
}
?>