<?php
session_start();
require_once ("includes/db.inc.php");
require_once ("includes/authenticate.inc.php");
require_once ("includes/funzioni.inc.php");

// connessione database, forzatura del charset
$connessione = mysqli_connect(DB_HOSTNAME, DB_USERNAME, DB_PASSWORD, DB_DATABASE);
mysqli_set_charset($connessione,"utf8");

sessionAuthenticate(HTTP_SERVER);


$url = '';

if (!empty($_GET['filtro_utente'])) {
	$url .= '&filtro_utente=' . urlencode(html_entity_decode($_GET['filtro_utente'], ENT_QUOTES, 'UTF-8'));
}

if (!empty($_GET['filtro_email'])) {
	$url .= '&filtro_email=' . urlencode(html_entity_decode($_GET['filtro_email'], ENT_QUOTES, 'UTF-8'));
}

if (isset($_GET['filtro_status'])) {
	$url .= '&filtro_status=' . urlencode(html_entity_decode($_GET['filtro_status'], ENT_QUOTES, 'UTF-8'));
}

if (!empty($_GET['filtro_expire'])) {
	$url .= '&filtro_expire=' . urlencode(html_entity_decode($_GET['filtro_expire'], ENT_QUOTES, 'UTF-8'));
}

if (isset($_GET['sort'])) {
	$url .= '&sort=' . $_GET['sort'];
}

if (isset($_GET['order'])) {
	$url .= '&order=' . $_GET['order'];
}

if (isset($_GET['page'])) {
	$url .= '&page=' . $_GET['page'];
}


if ($_SERVER['REQUEST_METHOD'] == 'POST') {

	$errori = array();
	
		if ((strlen(trim($_POST['first_name'])) < 1) || (strlen(trim($_POST['first_name'])) > 32)) {
			$errori['first_name'] = '<strong>First Name</strong> must be between 1 and 32 characters!';
		}

		if ((strlen(trim($_POST['last_name'])) < 1) || (strlen(trim($_POST['last_name'])) > 32)) {
			$errori['last_name'] = '<strong>Last Name</strong> must be between 1 and 32 characters!';
		}
		
		if(!empty($_POST['password'])){
			if ((strlen(html_entity_decode($_POST['password'], ENT_QUOTES, 'UTF-8')) < 4) || (strlen(html_entity_decode($_POST['password'], ENT_QUOTES, 'UTF-8')) > 40)) {
				$errori['password'] = '<strong>Password</strong> must be between 4 and 20 characters!';
			}

			if ($_POST['confirm'] != $_POST['password']) {
				$errori['confirm'] = '<strong>Password confirmation</strong> does not match password!';
			}
		}		

		if (strlen(trim($_POST['level'])) < 1) {
			$errori['level'] = 'Choose your <strong>membership package!</strong>';
		}
		
		/*
		if (strlen(trim($_POST['address_city'])) < 1) {
			$errori['address_city'] = 'Choose your <strong>town!</strong>';
		}		
		
		if (strlen(trim($_POST['address_state'])) < 1) {
			$errori['address_state'] = 'Choose your <strong>county!</strong>';
		}
		
		if (strlen(trim($_POST['id_country'])) < 1) {
			$errori['id_country'] = 'Choose your <strong>region!</strong>';
		}

		if (strlen(trim($_POST['address_zip'])) < 1) {
			$errori['address_zip'] = 'Choose your <strong>post code!</strong>';
		}	
		*/
	if (!$errori) {
		
		if($_GET['azione'] == 'insert_utente'){
			
		}else{
			$pay_frequency = $_POST['pay_frequency'];
			$giorni = "+40 days";
			if(!empty($pay_frequency)){
				if($pay_frequency == "1 M"){
					$giorni = "+40 days";
				}elseif($pay_frequency == "2 M"){
					$giorni = "+70 days";
				}elseif($pay_frequency == "3 M"){
					$giorni = "+100 days";
				}
			}
			// calcolo la prossima data di scadenza
			$pay_date_time = strtotime($_POST['pay_date']);
			$pay_next_datetime = date("Y-m-d", strtotime($giorni, $pay_date_time));				

			mysqli_query($connessione,"UPDATE wcrs_users SET level = '" . (int)$_POST['level']. "', date_registered = '" . mysqli_real_escape_string($connessione,$date_registered). "', first_name = '" . mysqli_real_escape_string($connessione,$_POST['first_name']). "', last_name = '" . mysqli_real_escape_string($connessione,$_POST['last_name']). "', address_street = '" . mysqli_real_escape_string($connessione,$_POST['address_street']). "', address_street2 = '" . mysqli_real_escape_string($connessione,$_POST['address_street2']). "', address_city = '" . mysqli_real_escape_string($connessione,$_POST['address_city']). "', address_state = '" . mysqli_real_escape_string($connessione,$_POST['address_state']). "',id_country=0,county_id = '" . (int)$_POST['id_country']. "', address_zip = '" . mysqli_real_escape_string($connessione,$_POST['address_zip']). "',  pay_frequency = '" . mysqli_real_escape_string($connessione,$_POST['pay_frequency']). "',  pay_expire = '".mysqli_real_escape_string($connessione,$pay_next_datetime)."', active = '" . (int)$_POST['active']. "' WHERE id = '" . (int)$_GET['id'] . "'") or die(mysqli_error());
			
			if(!empty($_POST['password'])){
				$salt = token(3);
				$token = token(32);
				$password = $_POST['password'];
				$hash = sha1($password);
				$hash = sha1($salt . $hash);			
				mysqli_query($connessione,"UPDATE wcrs_users SET password = '" . $hash. "',salt = '" . $salt. "', token = '" . $token. "' WHERE id = '" . (int)$_GET['id'] . "'") or die(mysqli_error());
			}
			
			$_SESSION["messaggio"] = '<div class="alert alert-success">Record update.</div>';
		}
	}
}

if(!isset($_GET['id'])){
	$form_azione = 'insert_utente';
}else{
	$form_azione = 'update_utente&id=' . $_GET['id'];
}

if (isset($_GET['id'])){
	$data = array();
	$query = mysqli_query($connessione,"SELECT * FROM wcrs_users WHERE id = '" . (int)$_GET['id'] . "'") or die(mysqli_error());
	$row = mysqli_fetch_array($query);
	$data['first_name'] = $row['first_name'];
	$data['last_name'] = $row['last_name'];
	$data['address_street'] = $row['address_street'];
	$data['address_street2'] = $row['address_street2'];
	$data['email'] = $row['email'];
	$data['contact_no'] = $row['contact_no'];
	$data['address_city'] = $row['address_city'];
	$data['address_state'] = $row['address_state'];
	$data['id_country'] = $row['county_id'];
	$data['address_zip'] = $row['address_zip'];
	$data['level'] = $row['level'];
	$data['active'] = $row['active'];
	$data['pay_frequency'] = $row['pay_frequency'];
	$data['pay_date'] = $row['pay_date'];
}

	if (isset($_POST['pay_date'])) {
		$pay_date = $_POST['pay_date'];
	} elseif (!empty($data)) { 
		$pay_date = $data['pay_date'];
	} else {
		$pay_date = "";
	}

	if (isset($_POST['contact_no'])) {
		$contact_no = $_POST['contact_no'];
	} elseif (!empty($data)) { 
		$contact_no = $data['contact_no'];
	} else {
		$contact_no = "";
	}

	if (isset($_POST['email'])) {
		$email = $_POST['email'];
	} elseif (!empty($data)) { 
		$email = $data['email'];
	} else {
		$email = "";
	}

	if (isset($_POST['first_name'])) {
		$first_name = $_POST['first_name'];
	} elseif (!empty($data)) { 
		$first_name = $data['first_name'];
	} else {
		$first_name = "";
	}
	
	if (isset($_POST['last_name'])) {
		$last_name = $_POST['last_name'];
	} elseif (!empty($data)) { 
		$last_name = $data['last_name'];
	} else {
		$last_name = "";
	}

	if (isset($_POST['address_street'])) {
		$address_street = $_POST['address_street'];
	} elseif (!empty($data)) { 
		$address_street = $data['address_street'];
	} else {
		$address_street = "";
	}
	
	if (isset($_POST['address_street2'])) {
		$address_street2 = $_POST['address_street2'];
	} elseif (!empty($data)) { 
		$address_street2 = $data['address_street2'];
	} else {
		$address_street2 = "";
	}	
	
	if (isset($_POST['address_city'])) {
		$address_city = $_POST['address_city'];
	} elseif (!empty($data)) { 
		$address_city = $data['address_city'];
	} else {
		$address_city = "";
	}

	if (isset($_POST['address_state'])) {
		$address_state = $_POST['address_state'];
	} elseif (!empty($data)) { 
		$address_state = $data['address_state'];
	} else {
		$address_state = "";
	}
	
	if (isset($_POST['id_country'])) {
		$id_country = $_POST['id_country'];
	} elseif (!empty($data)) { 
		$id_country = $data['id_country'];
	} else {
		$id_country = "";
	}

	if (isset($_POST['address_zip'])) {
		$address_zip = $_POST['address_zip'];
	} elseif (!empty($data)) { 
		$address_zip = $data['address_zip'];
	} else {
		$address_zip = "";
	}

	if (isset($_POST['level'])) {
		$level = $_POST['level'];
	} elseif (!empty($data)) { 
		$level = $data['level'];
	} else {
		$level = "";
	}

	if (isset($_POST['active'])) {
		$active = $_POST['level'];
	} elseif (!empty($data)) { 
		$active = $data['active'];
	} else {
		$active = "";
	}

	if (isset($_POST['pay_frequency'])) {
		$pay_frequency = $_POST['pay_frequency'];
	} elseif (!empty($data)) { 
		$pay_frequency = $data['pay_frequency'];
	} else {
		$pay_frequency = "";
	}	
?>
<!DOCTYPE html>
<html lang="en">
  <head>
    <meta charset="utf-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1">
<title></title>
<link href="css/bootstrap.min.css" rel="stylesheet">
<link href="https://fonts.googleapis.com/css?family=Open+Sans" rel="stylesheet">
<link rel="stylesheet" type="text/css" href="css/stile.css" />
<script src="https://ajax.googleapis.com/ajax/libs/jquery/1.11.3/jquery.min.js"></script>
<script src="js/bootstrap.min.js"></script>
<link rel="stylesheet" href="https://ajax.googleapis.com/ajax/libs/jqueryui/1.12.1/themes/smoothness/jquery-ui.css">
<script src="https://ajax.googleapis.com/ajax/libs/jqueryui/1.12.1/jquery-ui.min.js"></script>
<script type="text/javascript" src="js/jquery.mask.min.js"></script>
<script type="text/javascript"><!--
$(document).ready(function () {

	$( ".datepicker" ).datepicker({
		dateFormat: 'dd-mm-yy',
		changeMonth: true,
		changeYear: true
	});

	$('.datepicker').mask('99-99-9999');
});
//--></script> 
</head>
<body>
<div id="main">
<?php require('includes/header.php'); ?>
		<div id="content">
    	<div class="container">
        	<div class="row">
            	<div id="contenuto" class="col-xs-12">
                        <div class='page-header'>
                      		<div class='btn-toolbar pull-right'>
                            	<a href="utenti.php?cmd=back<?php echo $url;?>" class="btn btn-default">Back</a>
                      		</div>
                      		<h2><?php echo ($_GET['id']) ? 'Edit' : 'Insert';?> user #<?php echo $_GET['id'];?></h2>
                    	</div>                 
			<?php 
			mostraMessaggio();
			
			if(!empty($errori)){ 
				echo '<div class="alert alert-danger">';
				foreach($errori as $errore){
					echo $errore;
					echo '<br>';
				}
				echo '</div>';
			}
			?>

<form method="post" action="inserisci_utente.php?azione=<?php echo $form_azione.$url;?>" id="form">	
	<div class="row">
		<div class="col-md-6">
			<div class="form-group required">
				<label for="data_nascita" class="control-label">First name</label>
				<input type="text" class="form-control" name="first_name" value="<?php echo $first_name; ?>">
			</div>
		</div>
		<div class="col-md-6">
			<div class="form-group required">
				<label for="data_nascita" class="control-label">Last name</label>
				<input type="text" class="form-control" name="last_name" value="<?php echo $last_name; ?>">
			</div>
		</div>
	</div>		
	
		<div class="row">
		<div class="col-md-12">
			<div class="form-group required">
				<label for="data_nascita" class="control-label">Address Line 1</label>
			  <input type="text" class="form-control" name="address_street" value="<?php echo $address_street; ?>">
			</div>
		</div>
		</div>
		
		<div class="row">
		<div class="col-md-12">
			<div class="form-group">
			<label for="data_nascita" class="control-label">Address Line 2</label>
			  <input type="text" class="form-control" name="address_street2" value="<?php echo $address_street2; ?>" placeholder="Address Line 2">
			</div>
		</div>		
		</div>
		
		<div class="row">
		<div class="col-md-6">
			<div class="form-group required">
			<label for="data_nascita" class="control-label">Town</label>
			  <input type="text" class="form-control" name="address_city" value="<?php echo $address_city; ?>">
			</div>
			</div>
			<div class="col-md-6">
			<div class="form-group required">
			<label for="data_nascita" class="control-label">County</label>
			  <input type="text" class="form-control"  name="address_state" value="<?php echo $address_state; ?>">
			</div>
		</div>
		</div>
		
		<div class="row">
			<div class="col-md-6">
			<div class="form-group required">
				<label for="data_nascita" class="control-label">Region</label>
                            <select name="id_country" class="form-control">                         
                                <?php $loc_query_county = "SELECT * FROM tbl_county where 1 order by county_group_priority ASC";
                                $loc_exe_query_county   = mysqli_query($connessione,$loc_query_county);
                                //while($row_cat = mysqli_fetch_array($query_cat)) { 
                              		$loc_prev_county_group = '';
									while($row =mysqli_fetch_array($loc_exe_query_county)){
									    $loc_curr_county_group = $row['county_group'];
									    if($loc_prev_county_group != $loc_curr_county_group) {
									        if($loc_prev_county_group != '') {
									            echo '</optgroup>';
									        }
									        echo '<optgroup label="'.$loc_curr_county_group.'">';
									    }
									
									    $loc_prev_county_group = $loc_curr_county_group;
									?>
									    <option <?php  if ($row['county_id'] == $id_country) echo 'selected';?> value="<?php echo $row['county_id'] ?>"><?php echo $row['county_name'] ?></option>
								<?php	}
								echo '</optgroup>';
												       ?>
                            </select>			
			</div>
			</div>
			<div class="col-md-6">
			<div class="form-group required">
			<label for="data_nascita" class="control-label">Post Code</label>
			  <input type="text" class="form-control"  name="address_zip" value="<?php echo $address_zip; ?>">
			</div>
		</div>	
		</div>		
	
		<div class="row">
			<div class="col-md-6">
			<div class="form-group required">
				<label for="data_nascita" class="control-label">Email</label>
					<input type="text"  class="form-control" name="email" value="<?php echo $email; ?>" readonly  >
				</div>
			</div>
			<div class="col-md-6">
			<div class="form-group required">
				<label for="data_nascita" class="control-label">Phone</label>
					<input type="text"  class="form-control" name="contact_no" value="<?php echo $contact_no; ?>" readonly  >
				</div>
			</div>	
		</div>
		
		<div class="row">
			<div class="col-md-6">
			<div class="form-group required">
			<label for="data_nascita" class="control-label">Password</label>
				<input type="password"  class="form-control" name="password">
			</div>
			</div>
			<div class="col-md-6">
			<div class="form-group required">
				<label for="data_nascita" class="control-label">Repeat Password</label>
				<input type="password"  class="form-control" name="confirm" >
			</div>
		</div>
		</div>
		
		<div class="row">	
			<div class="col-md-6">
			<div class="form-group">
				<label for="data_nascita" class="control-label">Membership package</label>
				<select class="form-control" name="level">
					<option value="1" <?php if($level==1) echo 'selected';?>>Standard membership</option>
					<option value="2" <?php if($level==2) echo 'selected';?>>Premium membership</option>
					<option value="5" <?php if($level==5) echo 'selected';?>>Free membership</option>
					<option value="3" <?php if($level==3) echo 'selected';?>>Trade membership</option>
				</select>
			</div>	
		</div>
		<div class="col-md-6">
                        <div class="form-group">
                        	<label for="active" class="control-label">Status</label>
                          <select name="active" id="input-status" class="form-control">
                            <?php if ($active) { ?>
                            <option value="1" selected="selected">Active</option>
                            <option value="0">Not active</option>
                            <?php } else { ?>
                            <option value="1">Active</option>
                            <option value="0" selected="selected">Not active</option>
                            <?php } ?>
                          </select> 
                         </div>		
		</div>
		</div>
		<div class="row">
			<div class="col-md-6">
			<div class="form-group">
			<label for="pay_date" class="control-label">Pay date</label>
				<input type="text"  class="form-control" name="pay_date" value="<?php echo $pay_date; ?>" readonly  >
			</div>
		</div>			
			<div class="col-md-6">
			<div class="form-group">
				<label for="data_nascita" class="control-label">Pay frequency</label>
				<select class="form-control" name="pay_frequency">
					<option value="">--- Select ---</option>
					<option value="1 M" <?php if($pay_frequency=="1 M") echo 'selected';?>>1 M (40 days)</option>
					<option value="2 M" <?php if($pay_frequency=="2 M") echo 'selected';?>>2 M (70 days)</option>
					<option value="3 M" <?php if($pay_frequency=="3 M") echo 'selected';?>>3 M (100 days)</option>
				</select>
			</div>	
		</div>
	
		</div>
		
		
                <div class="text-right">
                	<button type="submit" class="btn btn-primary">
                    	<i class="glyphicon glyphicon-floppy-disk"></i> Salva
                   	</button>
              	</div>
			</form> 
				</div> 
    		</div>
    	</div>
    </div> 
</div> 
 <script type="text/javascript"><!--
function getZone(element, id_zona) {
  if (element.value != '') {
		$.ajax({
			url: 'json/zone.php?id_comune=' + element.value,
			dataType: 'json',
			beforeSend: function() {
				//$('select[name=\'id_comune\']').children().remove();
				//$('select[name=\'address[' + index + '][country_id]\']').after(' <i class="fa fa-circle-o-notch fa-spin"></i>');
			},
			complete: function() {
				//$('.fa-spin').remove();
			},
			success: function(json) {
				html = '<option value="">---Seleziona---</option>';
				if (json['zone']) {
					for (i = 0; i < json['zone'].length; i++) {
						html += '<option value="' + json['zone'][i]['id_zona'] + '"';

						if (json['zone'][i]['id_zona'] == id_zona) {
							html += ' selected="selected"';
						}

						html += '>' + json['zone'][i]['zona'] + '</option>';
					}
				} else {
					html += '<option value="Tutte le zone">Tutte le zone</option>';
				}

				$('select[name=\'id_zona\']').html(html);
			},
			error: function(xhr, ajaxOptions, thrownError) {
				alert(thrownError + "\r\n" + xhr.statusText + "\r\n" + xhr.responseText);
			}
		});
	}
}

$('select[name=\'id_comune\']').trigger('change');
//--></script> 
</body>
</html>