<?php
setlocale(LC_MONETARY, 'en_GB');
session_start();
require_once ("includes/db.inc.php");
require_once ("includes/authenticate.inc.php");
require_once ("includes/funzioni.inc.php"); 
require_once ("includes/pagination.class.php");

// connessione database, forzatura del charset
$connessione = mysqli_connect(DB_HOSTNAME, DB_USERNAME, DB_PASSWORD, DB_DATABASE);

mysqli_set_charset($connessione,"utf8");

sessionAuthenticate(HTTP_SERVER);

if(!empty($_GET["act"]) && $_GET["act"] == "del"){
	mysqli_query($connessione,"DELETE FROM rounds_wanted WHERE id = '" . (int)$_GET["id"] . "' LIMIT 1") or die (mysqli_error());		
	$_SESSION["messaggio"] = '<div class="alert alert-success">Record deteleted.</div>';
}

$record_per_pagina = 30;

if (isset($_GET['sort'])) {
	$sort = $_GET['sort'];
} else {
	$sort = 'id';
}

if (isset($_GET['order'])) {
	$order = $_GET['order'];
} else {
	$order = 'DESC';
}

if (isset($_GET['page'])) {
	$page = $_GET['page'];
} else {
	$page = 1;
}

$url = '';

if (isset($_GET['filtro_utente'])) {
	$url .= '&filtro_utente=' . urlencode(html_entity_decode($_GET['filtro_utente'], ENT_QUOTES, 'UTF-8'));
}

if (isset($_GET['filtro_email'])) {
	$url .= '&filtro_email=' . urlencode(html_entity_decode($_GET['filtro_email'], ENT_QUOTES, 'UTF-8'));
}


if ($order == 'ASC') {
	$url .= '&order=DESC';
} else {
	$url .= '&order=ASC';
}
		
if (isset($_GET['page'])) {
	$url .= '&page=' . $_GET['page'];
}

$sort_cognome = 'rounds_wanted.php?filtri=1&sort=last_name' . $url;
?>
<!DOCTYPE html>
<html lang="it">
  <head>
    <meta charset="utf-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <title>Rounds wanted</title>
<link href="css/bootstrap.min.css" rel="stylesheet">
<link href="https://fonts.googleapis.com/css?family=Open+Sans" rel="stylesheet">
<link rel="stylesheet" type="text/css" href="css/stile.css"/>
<script src="https://ajax.googleapis.com/ajax/libs/jquery/1.11.3/jquery.min.js"></script>
<script src="js/bootstrap.min.js"></script>
<link rel="stylesheet" href="https://ajax.googleapis.com/ajax/libs/jqueryui/1.12.1/themes/smoothness/jquery-ui.css">
<script src="https://ajax.googleapis.com/ajax/libs/jqueryui/1.12.1/jquery-ui.min.js"></script>
<script type="text/javascript" src="js/jquery.mask.min.js"></script>
<script type="text/javascript"><!--
$(document).ready(function () {
	$( ".datepicker" ).datepicker({
		dateFormat: 'dd-mm-yy',
		changeMonth: true,
		changeYear: true
	});

	$('.datepicker').mask('99-99-9999');
	
    $('[data-toggle="tooltip"]').tooltip();
});
//--></script> 
</head>
<body>
<div id="main">
	<?php require('includes/header.php'); ?>
	<div id="content">
    	<div class="container">
        	<div class="row">
            	<div id="contenuto" class="col-xs-12">
                     <div class='page-header'>
                      <h2>Rounds wanted</h2>
                    </div>  
                            
			<?php mostraMessaggio();?>
			<div class="well">
            <form method="get" action="rounds_wanted.php?filtri=1">	  
         
			<div class="row">
			<div class="col-sm-6">
				<div class="form-group">
					<label class="control-label" for="filtro_utente">Name</label>
					<input type="text" name="filtro_utente" id="filtro_utente" value="<?php echo $_GET['filtro_utente']; ?>" class="form-control" />
				</div>              
			</div>
			<div class="col-sm-6">
				<div class="form-group">
					<label class="control-label" for="filtro_email">Email</label>
					<input type="text" name="filtro_email" id="filtro_email" value="<?php echo $_GET['filtro_email'];?>" class="form-control"/> 
				</div>	
				<input type="submit" id="button-filter" class="btn btn-primary pull-right" value="Filter" />
			</div>			
			</div>	
        </form>	
		</div>			
		<div class="table-responsive">
            <table class="table table-bordered table-striped table-hover">
            	<thead>
   			  		<tr>
                    	<th class="text-center">ID</th>
						<th class="text-left">Name</th>
						<th class="text-left">Email</th>
						<th class="text-left">Telephone</th>	
						<th class="text-left">Location</th>
						<th class="text-right">Price</th>
                        <th class="text-center">Status</th>
						<th class="text-right">Date Added</th>
                  		<th class="text-center">Action</th>
            		</tr>
                </thead>
                <tbody>	
				<?php
				// $sql = "SELECT u.*, c.name AS location FROM rounds_wanted u LEFT JOIN country c ON (u.id_country=c.id_country) WHERE 1";
				$sql = "SELECT u.*, c.county_name AS location FROM rounds_wanted u LEFT JOIN tbl_county c ON (u.county_id=c.county_id) WHERE 1";
				
				//LEFT JOIN comuni c ON(u.id_comune=c.id_comune) LEFT JOIN zone z ON(z.id_zona=u.id_zona) WHERE 1";
				
				if(!empty($_GET['filtro_utente'])){
					$sql .= " AND LCASE(u.name) LIKE '%" . mysqli_real_escape_string($connessione,strtolower($_GET['filtro_utente'])) . "%'";
				}
				
				if(!empty($_GET['filtro_email'])){
					$sql .= " AND LCASE(email) LIKE '%" . mysqli_real_escape_string($connessione,strtolower($_GET['filtro_email'])) . "%'";
				}				
				
				$sort_data = array(
					'id',
					'last_name'
				);

				if (isset($sort) && in_array($sort, $sort_data)) {
					$sql .= " ORDER BY " . $sort;
				} else {
					$sql .= " ORDER BY id";
				}

				if (isset($order) && ($order == 'DESC')) {
					$sql .= " DESC";
				} else {
					$sql .= " ASC";
				}	
				
				$sql .= " LIMIT " . (int)($page-1)*$record_per_pagina . "," . (int)$record_per_pagina;
				
				$result = mysqli_query($connessione,$sql) or die(mysqli_error());
                if(mysqli_num_rows($result) >0){
                	while($row = mysqli_fetch_array($result)){						
                ?>	                                
    			<tr>
                	<td class="text-left"><?php echo $row['id'];?></td>
					<td class="text-left"><?php echo $row['name'];?></td>
					<td class="text-left"><?php echo $row['email'];?></td>
					<td class="text-left"><?php echo $row['telephone1'];?></td>
					<td class="text-left"><?php echo $row['location'];?></td>
					<td class="text-right"><?php echo $price = str_replace('GBP','&pound;',money_format('%i', $row['price']));?></td>
					<td class="text-center"><i class="glyphicon glyphicon-<?php echo ($row['status'] != 'new') ? 'ok' :'remove';?>"></i></td>
					<td class="text-right"><?php echo $row['date'];?></td>
					<td class="text-center">
						<a href="edit_rounds_wanted.php?id=<?php echo $row['id'];?>" data-toggle="tooltip" title="Modifica"><i class="glyphicon glyphicon-pencil"></i></a>	
						<a href="rounds_wanted.php?id=<?php echo $row['id'];?>&amp;act=del" onclick="return confirm('Sicuro di voler cancellare questo record?');"><i class="glyphicon glyphicon-trash"></i></a>  						
					</td>
  	    		</tr>
				<?php
					}
				}else{
					echo '<tr><td colspan="9" class="center">Record not found</td></tr>';
				}
				?>			
                </tbody>
          	</table>
			</div>
			<?php
			$sql = "SELECT COUNT(*) AS totale FROM rounds_wanted WHERE 1";
			
				if(!empty($_GET['filtro_utente'])){
					$sql .= " AND LCASE(name) LIKE '%" . mysqli_real_escape_string($connessione,strtolower($_GET['filtro_utente'])) . "%'";
				}
				
				if(!empty($_GET['filtro_email'])){
					$sql .= " AND LCASE(email) LIKE '%" . mysqli_real_escape_string($connessione,strtolower($_GET['filtro_email'])) . "%'";
				}				
			
			$result = mysqli_query($connessione,$sql) or die(mysqli_error());
            $row = mysqli_fetch_array($result);
			$totale = $row['totale'];			

			$url = preg_replace("/&page=\d+/", '', $_SERVER['REQUEST_URI']) ;
            $cp = new CreativePager();
			$parametri['class'] = 'pagination';
            $parametri['selected_page'] = $page;
            $parametri['total_items']	= $totale;
            $parametri['items_per_page'] = $record_per_pagina;
            $parametri['url'] = $url;
            $parametri['nav_pages'] = 10;
            $parametri['info1'] = false;
            $parametri['info2'] = false;
            $parametri['first'] = 'Prev';
            $parametri['last']	= 'Next';
            $cp->pager($parametri);
            echo utf8_encode($cp->display());
            ?>
			<div class="clear"></div>
            	</div>
            	</div>
            </div>
		</div>
</div>
<script type="text/javascript"><!--
$('#button-filter').on('click', function() {
	url = 'utenti.php?filtri=1';
	
	var filtro_utente = $('input[name=\'filtro_utente\']').val();
	if (filtro_utente) {
		url += '&filtro_utente=' + encodeURIComponent(filtro_utente);
	}

	var filtro_email = $('input[name=\'filtro_email\']').val();
	if (filtro_email) {
		url += '&filtro_email=' + encodeURIComponent(filtro_email);
	}	
	
	location = url;
});
//--></script> 
</body>
</html>