<?php
require("./vendor/stripe.config.php");

$priceId = null;

if(isset($_POST['submit']) && strtolower($_POST['submit']) == "subscribe"){

    $level = isset($_POST['level']) ? $_POST['level'] : null;

    if($level == 1){
        $priceId = STD_PRICE_ID;
    }   elseif($level == 2){
        $priceId = PRE_PRICE_ID;
    }elseif($level == 3){
        $priceId = TRD_PRICE_ID;
    } 

    if($priceId != null){
        
        try{
            require "./vendor/autoload.php";

            $stripe = new \Stripe\StripeClient(STRIPE_KEY);
            
            if(isset($_POST['subscr_id']) && $_POST['subscr_id'] == "NEW"){

                $checkout_session = $stripe->checkout->sessions->create([
                    "success_url" => PAYMENT_SUCCESS_URL."?session={CHECKOUT_SESSION_ID}",
                    "cancel_url" => PAYMENT_CANCEL_URL,
                    "payment_method_types" => ['card'],
                    "customer"=> $_POST['customer_id'],
                    //"customer_email" => $_POST["email"],
                    "mode" => "payment",
                    "line_items" => [
                        [
                            "price" => $priceId,
                            "quantity" => 1
                        ]
                    ],
                    "metadata" =>[
                        "user" => $_POST['uid']
                    ]
                ]);

            }else{

                $checkout_session = $stripe->checkout->sessions->create([
                    "success_url" => PAYMENT_SUCCESS_URL."?session={CHECKOUT_SESSION_ID}&level=".$level,
                    "cancel_url" => PAYMENT_CANCEL_URL."?user=".$_POST['uid'],
                    "payment_method_types" => ['card'],
                    "customer"=> $_POST['customer_id'],
                    "mode" => "payment",
                    "line_items" => [
                        [
                            "price" => $priceId,
                            "quantity" => 1
                        ]
                    ],
                    "metadata" =>[
                        "user" => $_POST['uid'],
                        "subscription" => $_POST['subscr_id']
                    ]
                ]);

            }

            header("HTTP/1.1 303 See Other");
            header("Location: " . $checkout_session->url);
        }catch (Error $e) {
            http_response_code(500);
            echo json_encode(['error' => $e->getMessage()]);
        }

    }else{
        ?>
        <h1>Invalid payment details, please try again later.</h1>
    <?php
        header("refresh:3;url=".HTTP_SERVER);
    }
}
else{
    ?>
        <h1>Invalid payment URL...</h1>
    <?php
    header("refresh:3;url=".HTTP_SERVER);
}
?>