<?php 
setlocale(LC_MONETARY, 'en_GB');
session_start();
require_once('Connections/rounds4sale.php');
require_once("includes/pagination.class.php");

$connessione = mysqli_connect($hostname_cleaningrounds, $username_cleaningrounds, $password_cleaningrounds, $database_cleaningrounds);
mysqli_set_charset($connessione,"utf8");

$titolo = "Vehicles and Equipment For Sale";
$record_per_pagina = 20;

if (isset($_GET['sort'])) {
	$sort = $_GET['sort'];
} else {
	$sort = 'date_insert';
}

if (isset($_GET['order'])) {
	$order = $_GET['order'];
} else {
	$order = 'DESC';
}

if (isset($_GET['page'])) {
	$page = $_GET['page'];
} else {
	$page = 1;
}

$url = '';

if (isset($_GET['location_display'])) {
	$url .= '&location_display=' . urlencode(html_entity_decode($_GET['location_display'], ENT_QUOTES, 'UTF-8'));
}

if (isset($_GET['search_location'])) {
	$url .= '&search_location=' . urlencode(html_entity_decode($_GET['search_location'], ENT_QUOTES, 'UTF-8'));
}

if (isset($_GET['filter_price'])) {
	$url .= '&filter_price=' . urlencode(html_entity_decode($_GET['filter_price'], ENT_QUOTES, 'UTF-8'));
}

if ($order == 'ASC') {
	$url .= '&order=DESC';
} else {
	$url .= '&order=ASC';
}
		
if (isset($_GET['page'])) {
	$url .= '&page=' . $_GET['page'];
}

$sql = "SELECT COUNT(*) AS totale FROM equipment t LEFT JOIN country c ON (t.id_country=c.id_country) WHERE (status = 'live' OR status = 'sold')";
								
if(!empty($_GET['location_display'])){
	$sql .= " AND t.id_country = '" . (int)$_GET['location_display']."' ";
}
								
if(!empty($_GET['search_location'])){
	$sql .= "AND (c.name LIKE '%" . mysqli_real_escape_string($connessione,$_GET['search_location'])."%' OR description LIKE '%" . mysqli_real_escape_string($connessione,$_GET['search_location'])."%')";
}	

if(!empty($_GET['county_display'])){
	$sql .= " AND t.county_id = '" . $_GET['county_display']."' ";
}
	

if(!empty($_GET['filter_price']) && $_GET['filter_price'] != 'Show All'){	
	if(strpos($_GET['filter_price'], "+") !== false){
		$sql .= " AND price > '".ltrim($_GET['filter_price'], '+')."'";
	}else{
		$sql .= " AND price <= '".$_GET['filter_price']."'";
	}			
}
								
$result = mysqli_query($connessione,$sql) or die(mysqli_error());
$row = mysqli_fetch_array($result);
$totale = $row['totale'];

$loc_query_county       = "SELECT * FROM tbl_county where 1 order by county_group_priority ASC";
$loc_exe_query_county   = mysqli_query($connessione,$loc_query_county);
?>
<!DOCTYPE html>
<html lang="it">
<head>
<meta charset="utf-8">
<meta http-equiv="X-UA-Compatible" content="IE=edge">
<meta name="viewport" content="width=device-width, initial-scale=1">
<title>Window Cleaning Vehicles and Equipment For Sale</title>
<meta name="Description" content="Window cleaning vehicles and equipment for sale. Advertise your window cleaning equipment.">
<meta name="Keywords" content="window cleaning equipment, window cleaning equipment for sale, window cleaning vehicles, window cleaning vehicles for sale">
<meta name="Generator" content="NetObjects Fusion 11 for Windows">
<link href="assets/css/bootstrap.min.css" rel="stylesheet">
<link rel="stylesheet" href="https://use.fontawesome.com/releases/v5.3.1/css/all.css" integrity="sha384-mzrmE5qonljUremFsqc01SB46JvROS7bZs3IO2EmfFsd15uHvIt+Y8vEf7N7fWAU" crossorigin="anonymous">
 <link href="assets/css/style.css" rel="stylesheet">
<link href="https://fonts.googleapis.com/css?family=Open+Sans" rel="stylesheet">

<link rel="stylesheet" type="text/css" href="assets/css/jquery.fancybox.min.css">
<script src="https://ajax.googleapis.com/ajax/libs/jquery/1.11.3/jquery.min.js"></script>
<script src="assets/js/bootstrap.min.js"></script>
<script src="assets/js/jquery.fancybox.min.js"></script>
<script type="text/javascript" src="./index.js">
</script>
<script>
var text1="Advertise your window cleaning round for sale for free with www.windowcleaningresources.co.uk"
comeback=0
cometo=0
function dis(){
window.status=text1.substring(0,cometo)
if(comeback==1){
cometo--;
if(cometo==0){comeback=0}
} else {cometo++;if(cometo==text1.length){comeback=1}}
window.status=text1.substring(0,cometo)+"|"
if(cometo==text1.length){window.setTimeout("dis()",500);} else {window.setTimeout("dis()",75);}
}
dis()
</script>
</head>
<body>
<div id="wrapper">

	<?php require_once("includes/header.php");?>

	<?php require_once("includes/subheader.php");?>
	
	<div class="main-container">
		<div class="container">
			<div class="row">
				<div class="col-md-9 page-content">
					<div class="content-box col-xl-12">
						<div class="row row-featured row-featured-category">
		
							<div class="col-xl-12  box-title no-border">
                                <div class="inner">
                                
                                <h2 class="text-center">Vehicles and Equipment (<?php echo $totale;?>)</h2>
						</div>	
						<div class="row">
							<div class="col-xl-12">
								<div class="card">
									<div class="card-header">Search</div>
									<div class="card-body">
										<form method="get" action="equipment.php?filter=1">
											<div class="row">
												<div class="col-sm-6 col-md-6 col-lg-3">
													<div class="form-group">
														<label for="location_display" class="sr-only">Region</label>
														
														<?php /* ?><select name="location_display" class="form-control">
															<option value="">Select Region</option> 															
															<?php 
															$query_cat = mysqli_query($connessione,"SELECT * FROM country ORDER BY postcode_required DESC, id_country ASC");
															while($row_cat = mysqli_fetch_array($query_cat)) { 
															?>     
															<option <?php if ($row_cat['id_country'] == $_GET['location_display']) echo 'selected="selected"';?> value="<?php echo $row_cat['id_country']; ?>"><?php echo $row_cat['name']; ?></option> 
															<?php } ?>                                              
														</select> <?php */?>

														<select name="county_display" class="form-control">
												       <option value="">Select Region</option>
												       <?php
												       $loc_prev_county_group = '';
												       
									while($row =mysqli_fetch_array($loc_exe_query_county)){
									    $loc_curr_county_group = $row['county_group'];
									    if($loc_prev_county_group != $loc_curr_county_group) {
									        if($loc_prev_county_group != '') {
									            echo '</optgroup>';
									        }
									        echo '<optgroup label="'.$loc_curr_county_group.'">';
									    }
									
									    $loc_prev_county_group = $loc_curr_county_group;
									?>
									    <option value="<?php echo $row['county_id'] ?>" <?php if ($_GET['county_display'] == $row['county_id'] ) echo 'selected';?>><?php echo $row['county_name'] ?></option>
								<?php	}
								echo '</optgroup>';
												       ?>
														</select>
													</div>
											  </div>
											  <div class="col-sm-6 col-md-6 col-lg-3">
												  <div class="form-group">
													<label for="search_location" class="sr-only">Keywords</label>
													<input type="text" class="form-control" name="search_location" value="<?php echo $_GET['search_location'];?>" placeholder="Keywords">
												  </div>
											  </div>
											  <div class="col-sm-8 col-md-8 col-lg-3">
												<div class="form-group">
													<label for="filter_price" class="sr-only">Budget</label>
													<select name="filter_price" class="form-control">
														<option value="">Maximum Price</option> 
														<option value="500" <?php if ($_GET['filter_price'] == '500') echo 'selected';?>>500</option> 
														<option value="1000" <?php if ($_GET['filter_price'] == '1000') echo 'selected';?>>1,000</option> 
														<option value="2500" <?php if ($_GET['filter_price'] == '2500') echo 'selected';?>>2,500</option> 
														<option value="5000" <?php if ($_GET['filter_price'] == '5000') echo 'selected';?>>5,000</option> 
														<option value="10000" <?php if ($_GET['filter_price'] == '10000') echo 'selected';?>>10,000</option> 
														<option value="15000" <?php if ($_GET['filter_price'] == '15000') echo 'selected';?>>15,000</option> 
														<option value="20000" <?php if ($_GET['filter_price'] == '20000') echo 'selected';?>>20,000</option> 
														<option value="35000" <?php if ($_GET['filter_price'] == '35000') echo 'selected';?>>35,000</option> 
														<option value="50000" <?php if ($_GET['filter_price'] == '50000') echo 'selected';?>>50,000</option> 
														<option value="Show All" <?php if ($_GET['filter_price'] == "Show All") echo 'selected';?>>Show All</option> 
													</select>			 
												  </div>
											  </div>
											  <div class="col-sm-4 col-md-4 col-lg-3">
												<button type="submit" class="btn btn-primary btn-lg btn-block">Filter</button>
											  </div>
											</div>
										</form>
									</div>
								</div>
</div>
</div>
<div class="row">
<div class="col-xl-12">
      <div class="adds-wrapper jobs-list">              
	 
								<?php
								$sql = "SELECT t.*, c.name AS region, ct.county_name FROM equipment t 
								LEFT JOIN tbl_county ct  on t.county_id = ct.county_id
								LEFT JOIN country c ON (t.id_country=c.id_country) WHERE (status = 'live' OR status = 'sold')";
								
								if(!empty($_GET['location_display'])){
									$sql .= " AND t.id_country = '" . (int)$_GET['location_display']."' ";
								}
								
								if(!empty($_GET['search_location'])){
									$sql .= "AND (c.name LIKE '%" . mysqli_real_escape_string($connessione,$_GET['search_location'])."%' OR description LIKE '%" . mysqli_real_escape_string($connessione,$_GET['search_location'])."%')";
								}	

								
								if(!empty($_GET['county_display'])){
									$sql .= " AND t.county_id = '" . $_GET['county_display']."' ";
								}
								
								if(!empty($_GET['filter_price']) && $_GET['filter_price'] != 'Show All'){	
									if(strpos($_GET['filter_price'], "+") !== false){
										$sql .= " AND price > '".ltrim($_GET['filter_price'], '+')."'";
									}else{
										$sql .= " AND price <= '".$_GET['filter_price']."'";
									}			
								}								
				
								$sort_data = array(
									'id',
									'date_insert',
								);

								if (isset($sort) && in_array($sort, $sort_data)) {
									$sql .= " ORDER BY " . $sort;
								} else {
									$sql .= " ORDER BY id";
								}

								if (isset($order) && ($order == 'DESC')) {
									$sql .= " DESC";
								} else {
									$sql .= " ASC";
								}	
								
								$sql .= " LIMIT " . (int)($page-1)*$record_per_pagina . "," . (int)$record_per_pagina;			
								$result = mysqli_query($connessione,$sql) or die(mysqli_error());

								if(mysqli_num_rows($result) >0){
									while($row_showAds = mysqli_fetch_array($result)){	
?>
<div class="item-list job-item">
<?php									
	 
		   // Is this a trade advert?
	   $custLevel = $row_showAds['custLevel'];
	   
	   if($custLevel == "3")
	   {
	       $postedBy = " by a Trade Member";
		   $adClass = "tradeAdvertResulBox"; 
	   }
	   else
	   {
	       $postedBy = "";
		   $adClass = "advertResulBox";
	   } 
$image_exists = "false"; 
$image_file_name = $row_showAds['image_file_name'];
if( ($wanted != "true") &&(isset($image_file_name) && $image_file_name != "")){
	$image_location = "./equipmentforsale/photos/" . $image_file_name;
	if(is_file($image_location)){
		$image_exists = "true"; 
		echo '<div class="float-left mr10">';
		echo '<a href="' . $image_location . '" data-fancybox="images">';
		echo '<figure class="figure">';
		echo '<img src="' . $image_location . '" alt="" width="150" class="img-thumbnail rounded float-left">';
		echo '<figcaption class="figure-caption text-center"><small>(click on image to see full size)</small></figcaption>';
		echo '</figure>';
		echo '</a>';
		echo '</div>';
	}
} 		
?>    
        <strong><span class="style28">Posted on <?php echo $row_showAds['date']; echo $postedBy; ?></span></strong><br />
        
        
        <!-- insert table here -->
       
        <div align="left">
        

	       		  	   <strong>Region:</strong> <?php echo $row_showAds['county_name']; ?><br /> 
	       		  	   <strong>Condition:</strong> <?php echo $row_showAds['condition1']; ?><br />
				       <strong>Product:</strong> <?php echo $row_showAds['product']; ?><br />
              
			  <strong>Description: </strong><span class="style27">
			
			
				<?php if($wanted == "true")
				      {
					  	echo $row_showAds['comments']; 
					  } 
					  else
					  {
					  	echo $row_showAds['description']; 
					  }?>
                
                
                </span>
			<br />
        
        <?php
		
		$status = $row_showAds['status'];
			
			if($status == "sold")
			{
			    $price = "SOLD"; 
			}
			else
			{
			    $price = str_replace('GBP','&pound;',money_format('%i', $row_showAds['price']));		
			}
		
		?>
        
        
        <?php if($wanted != "true") { ?>

        	<strong>Price :</strong> <?php echo $price; ?><br />
        <?php } ?>
        
        <?php
		// only reveal contact details to members UNLESS it's a trade advert
		if($_SESSION['session_level'] == 5){
		?>
		<a href="user_settings.php" style="color:#0033FF"><b>Upgrade your membership to see contact details</b></a><br>  
		<?php }elseif($_SESSION['session_level'] > 0 || $trade == "1"){ ?>
		<strong>Contact Details :</strong> <?php echo $row_showAds['name']; ?> - 
		<?php echo $row_showAds['telephone1']; 
		      if(!empty($row_showAds['telephone2']))
			  {
			      echo " or " . $row_showAds['telephone2'];
			  }?>  - <a href="mailto:<?php echo $row_showAds['email']; ?>?subject=WCR site - Advert Enquiry">[Send Email] </a></span>
        
        <?php }else{ ?>
			<a href="register_form.php" style="color:#0033FF"><b>Register as a member to view contact details</b></a><br>  
         <?php 	} 	?>
        
      </div>
	  </div>
    <?php 
	} 
	}else{
		echo '<h1>No result found!</h1>';
	}		
	?>
     
     
			<nav aria-label="Page navigation example">
			<?php
			$url = preg_replace("/&page=\d+/", '', $_SERVER['REQUEST_URI']) ;
            $cp = new CreativePager();
			$parametri['class'] = 'pagination';
            $parametri['selected_page'] = $page;
            $parametri['total_items']	= $totale;
            $parametri['items_per_page'] = $record_per_pagina;
            $parametri['url'] = $url;
            $parametri['nav_pages'] = 5;
            $parametri['info1'] = false;
            $parametri['info2'] = false;
            $parametri['first'] = 'Prev';
            $parametri['last']	= 'Next';
            $cp->pager($parametri);
            echo utf8_encode($cp->display());
            ?>  
			</nav>
  
  </div> 
							</div> 
						</div>
					</div>
				</div>
  </div>
  </div>

				<div class="col-md-3 page-sidebar">
					<?php require_once('incLeftMenu.php'); ?>
				</div>
			</div>
		</div>
	</div>
 
	<?php //require("footer.php"); ?>
	<div id="sub-footer">
		<div class="container">
			<div class="row">
				<div class="col-md-12 col-sm-12 col-xs-12 text-center">
					<h3>Window Cleaning Resources - All you need to succeed</h3>
					<p>www.windowcleaningroundforsale.co.uk is regularly visited by thousands of window cleaners each month.
					If you are a supplier to the trade and would like to advertise your company on this site please <a href="http://www.windowcleaningresources.co.uk/contact-us/pay-advertising/">contact us</a>.</p>		
					<img src="https://www.windowcleaningrounds.co.uk/wp-content/uploads/2018/05/windowcleaningroundforsale.png" class="img-fluid">				
				</div>
			</div>
		</div>
	</div>
    <?php require_once("includes/footer.php");?>
</div>	
</body>
</html>