<?php

if(isset($_GET['action']) && $_GET['action'] == 'setup'){
	$obj = new EmailController();
	//echo $obj->send_pay_reminder();
	//echo $obj->run_setup();
	//echo $obj->run_setup_2();
	//$obj->create_2_lists();
	//echo $obj->create_list("Subscriber List", "Sample Subject Line", "d9554f26e9");
}

class EmailController
{
	private $mailchimp;
	private $email_model;
	private $template_model;

	public function __construct()
	{
		require dirname(__FILE__)."/Mailchimp.php";
		require dirname(__FILE__)."/EmailModel.php";
		require dirname(__FILE__)."/TemplateModel.php";
		$this->mailchimp = new Mailchimp();
		$this->email_model = new EmailModel();
		$this->template_model = new TemplateModel();
	}

	public function run_setup(){
		if($this->email_model->clean_campaign() === true){
			$folder = $this->create_campaign_folder("Window Clean");
			//print_r($folder);
			if($folder['status'] == 200){
				$folder_id = $folder['response']['id'];
				$campaign = $this->mailchimp->create_new_campaign(array(
					"type" => "regular",
					"settings" => array(
						"subject_line" => "Please pay your subscription amount",
						"title" => "Pay Reminder",
						"from_name" => "Window Cleaning Rounds",
						"reply_to" => "no-reply@gmail.com",
						"folder_id" => $folder_id
					)
				));

				if($campaign['status'] == 200){
					//print_r($campaign['response']['id']);
					$campaign_id = $campaign['response']['id'];
					if($this->email_model->add_campaign_db($campaign_id, $folder_id, "pay_reminder") === true){
						$createlist = $this->create_list("Subscriber List", "Sample Subject", $campaign_id);
						echo "<pre>";
						print_r($createlist);
						echo "Setup completed successfully";
					}else{
						echo "Error occurred in MYSQL Query";
					}
				}else{
					echo "Error in creating campaing, please try again";
				}

			}else{
				echo $folder['detail'];
			}
		}else{
			echo "Error in cleaning & creating database table";
		}
	}

	public function run_setup_2(){
		$campaign = $this->email_model->get_campaign_db("pay_reminder");
		if(!empty($campaign)){
			$folder_id = $campaign['folder_id'];
			$this->create_campaign($folder_id, "Please upgrade your subscription", "Upgrade Subscription", "upgrade_reminder");
			$this->create_campaign($folder_id, "Please upgrade your subscription to premium", "Upgrade to Premium Subscription", "upgrade_to_premium");
			$this->create_campaign($folder_id, "Please pay your failed subscription amount", "Pay failed Subscription Amount", "failed_reminder");
			$this->create_campaign($folder_id, "Please complete your sign up and pay now", "Complete your sign up", "cancelled_sign_up");
		}
	}

	public function create_campaign($folder_id, $subject, $title, $template){
		$campaign = $this->mailchimp->create_new_campaign(array(
			"type" => "regular",
			"settings" => array(
				"subject_line" => $subject,
				"title" => $title,
				"from_name" => "Window Cleaning Rounds",
				"reply_to" => "no-reply@gmail.com",
				"folder_id" => $folder_id
			)
		));

		if($campaign['status'] == 200){
			$campaign_id = $campaign['response']['id'];
			if($this->email_model->add_campaign_db($campaign_id, $folder_id, $template) === true){
				$this->create_list("Subscriber List ".$campaign_id, $title, $campaign_id);
				echo "Setup completed successfully";
			}else{
				echo "Error occurred in MYSQL Query";
			}
		}else{
			echo "Error in creating campaing, please try again";
		}
	}

	public function create_campaign_folder($folder){
		
		$folderExits = $this->mailchimp->get_folders($folder);
		if($folderExits == null){
			$title = array("name"=>$folder);
			$create = $this->mailchimp->create_campaign_folder($title);
			if($create['status'] == 200){
				return $create;
			}else{
				return $create;
			}
		}
		return array("status"=>200, "detail"=>"Folder already exists");

	}

	public function create_2_lists(){
		
		$list = array(
			"name" => "Please pay your failed subscription amount",
			"contact" => array(
				"company"=> "Window Cleaning Rounds",
				"address1"=>"Sample Address",
				"address2"=>"Address Line 2",
				"city"=>"London",
				"state"=>"LND",
				"zip"=>"343555",
				"country"=>"UK",
				"phone"=>""
			),
			"permission_reminder"=>"Sample Reminder Text",
			"campaign_defaults" => array(
				"from_name"=>"Window Cleaning Rounds",
				"from_email"=>"no-reply@gmail.com",
				"subject"=> "Pay failed Subscription Amount",
				"language"=>"en",
				
			),
			"email_type_option"=>true
		);
		$mailChimpList = $this->mailchimp->create_list($list);
		print_r($mailChimpList);
		if($mailChimpList['status'] == 200){
			return $this->email_model->add_list_id($mailChimpList['response']['id'], '1fa225e3a9');
		}
		
		$list2 = array(
			"name" => "Please complete your sign up and pay now",
			"contact" => array(
				"company"=> "Window Cleaning Rounds",
				"address1"=>"Sample Address",
				"address2"=>"Address Line 2",
				"city"=>"London",
				"state"=>"LND",
				"zip"=>"343555",
				"country"=>"UK",
				"phone"=>""
			),
			"permission_reminder"=>"Sample Reminder Text",
			"campaign_defaults" => array(
				"from_name"=>"Window Cleaning Rounds",
				"from_email"=>"no-reply@gmail.com",
				"subject"=> "Complete your sign up",
				"language"=>"en",
				
			),
			"email_type_option"=>true
		);
		$mailChimpList2 = $this->mailchimp->create_list($list2);
		print_r($mailChimpList2);
		if($mailChimpList2['status'] == 200){
			return $this->email_model->add_list_id($mailChimpList2['response']['id'], 'd53f839ddf');
		}
	}

	public function create_list($title, $subject, $campaign_id){
		$list = array(
			"name" => $title,
			"contact" => array(
				"company"=> "Window Cleaning Rounds",
				"address1"=>"Sample Address",
				"address2"=>"Address Line 2",
				"city"=>"London",
				"state"=>"LND",
				"zip"=>"343555",
				"country"=>"UK",
				"phone"=>""
			),
			"permission_reminder"=>"Sample Reminder Text",
			"campaign_defaults" => array(
				"from_name"=>"Window Cleaning Rounds",
				"from_email"=>"no-reply@gmail.com",
				"subject"=>$subject,
				"language"=>"en",
				
			),
			"email_type_option"=>true
		);
		$mailChimpList = $this->mailchimp->create_list($list);
		print_r($mailChimpList);
		if($mailChimpList['status'] == 200){
			return $this->email_model->add_list_id($mailChimpList['response']['id'], $campaign_id);
		}else{
			return false;
		}
	}

	public function update_campaigns(){
		$c1 = $this->mailchimp->update_campaign("09b28aad15", [
				"recipients"=> [
						"list_id"=>"d08ac07e61"
				]
			]
		);
		$c2 = $this->mailchimp->update_campaign("32cb71769f", [
				"recipients"=> [
						"list_id"=>"376ed54a43"
				]
			]
		);
		$c3 = $this->mailchimp->update_campaign("8fd7f00bf7", [
				"recipients"=> [
						"list_id"=>"3120928939"
				]
			]
		);
		$c4 = $this->mailchimp->update_campaign("1fa225e3a9", [
				"recipients"=> [
						"list_id"=>"d08ac07e61"
				]
			]
		);
		$c5 = $this->mailchimp->update_campaign("d53f839ddf", [
				"recipients"=> [
						"list_id"=>"d08ac07e61"
				]
			]
		);

		/* echo "<pre>";
		print_r($c1);
		print_r($c2);
		print_r($c3);
		print_r($c4);
		print_r($c5); */
	}
	
	
	/*Actul Code after setup*/
	
	public function send_pay_reminder(){
		//$this->create_campaign_folder("Window Clean");
		$campaign = $this->email_model->get_campaign_db("pay_reminder");
		if(!empty($campaign)){
			$members = $this->email_model->get_pay_reminder_data();
			//print_r($members); die;
			$subscribe = $this->mailchimp->batch_subscribe_list($campaign['list_id'], ["members" => $members]);
			//print_r($subscribe); die;
			$setRecipients = $this->mailchimp->update_campaign($campaign['campaign_id'], [
					"recipients"=> [
							"list_id"=>$campaign['list_id']
					]
				]
			);
			if($subscribe['status'] == 200){
				$msg = "Total Added - ".$subscribe['total_created'].", Total Updated - ".$subscribe['total_updated'].", Error -".$subscribe['error_count'];
				return $this->send($campaign['campaign_id'], "pay_reminder");
			}
			else{
				return $subscribe;
			}
		}else{
			return "Campaign not found by template name 'pay_reminder'.";
		}
	}

	public function send_upgrade_reminder(){
		$campaign = $this->email_model->get_campaign_db("upgrade_reminder");
		if(!empty($campaign)){
			$members = $this->email_model->get_upgrade_reminder_data();
			//echo "<pre>";
			//print_r($members);
			$subscribe = $this->mailchimp->batch_subscribe_list($campaign['list_id'], ["members" => $members] );
			//print_r($subscribe);
			$setRecipients = $this->mailchimp->update_campaign($campaign['campaign_id'], [
					"recipients"=> [
							"list_id"=>$campaign['list_id']
					]
				]
			);
			if($subscribe['status'] == 200){
				$msg = "Total Added - ".$subscribe['total_created'].", Total Updated - ".$subscribe['total_updated'].", Error -".$subscribe['error_count'];
				return $this->send($campaign['campaign_id'], "upgrade_reminder");
			}
			else{
				return $subscribe;
			}
		}else{
			return "Campaign not found by template name 'upgrade_reminder'.";
		}
	}

	public function send_upgrade_to_premium(){
		$campaign = $this->email_model->get_campaign_db("upgrade_to_premium");
		if(!empty($campaign)){
			$members = $this->email_model->get_upgrade_premium_data();
			$subscribe = $this->mailchimp->batch_subscribe_list($campaign['list_id'], ["members" => $members]);
			$setRecipients = $this->mailchimp->update_campaign($campaign['campaign_id'], [
					"recipients"=> [
							"list_id"=>$campaign['list_id']
					]
				]
			);
			if($subscribe['status'] == 200){
				$msg = "Total Added - ".$subscribe['total_created'].", Total Updated - ".$subscribe['total_updated'].", Error -".$subscribe['error_count'];
				return $this->send($campaign['campaign_id'], "upgrade_to_premium");
			}
			else{
				return $subscribe;
			}
		}else{
			return "Campaign not found by template name 'upgrade_to_premium'.";
		}
	}

	public function send_failed_payment_reminder(){
		$campaign = $this->email_model->get_campaign_db("failed_reminder");
		if(!empty($campaign)){
			
			$members = $this->email_model->get_failed_payment_data();
			//print_r($members);
			$subscribe = $this->mailchimp->batch_subscribe_list($campaign['list_id'], ["members" => $members]);
			//print_r($subscribe);
			$setRecipients = $this->mailchimp->update_campaign($campaign['campaign_id'], [
					"recipients"=> [
							"list_id"=>$campaign['list_id']
					]
				]
			);
			if($subscribe['status'] == 200){
				$msg = "Total Added - ".$subscribe['total_created'].", Total Updated - ".$subscribe['total_updated'].", Error -".$subscribe['error_count'];
				return $this->send($campaign['campaign_id'], "failed_reminder");
			}
			else{
				return $subscribe;
			}
		}else{
			return "Campaign not found by template name 'failed_reminder'.";
		}
	}

	public function send_cancelled_reminder(){
		$campaign = $this->email_model->get_campaign_db("cancelled_sign_up");
		if(!empty($campaign)){
			
			$members = $this->email_model->get_cancelled_data();
			$subscribe = $this->mailchimp->batch_subscribe_list($campaign['list_id'], ["members" => $members]);
			$setRecipients = $this->mailchimp->update_campaign($campaign['campaign_id'], [
					"recipients"=> [
							"list_id"=>$campaign['list_id']
					]
				]
			);
			if($subscribe['status'] == 200){
				$msg = "Total Added - ".$subscribe['total_created'].", Total Updated - ".$subscribe['total_updated'].", Error -".$subscribe['error_count'];
				return $this->send($campaign['campaign_id'], "cancelled_sign_up");
			}
			else{
				return $subscribe;
			}
		}else{
			return "Campaign not found by template name 'cancelled_sign_up'.";
		}
	}
	
	public function batch_subscribe($members){

	}

	public function test_email($campaign_id, $email, $template){
		if($email){
			if($campaign_id){
				$html = ""; $testStatus = false;
				//$content=$this->mailchimp->campaign_content($campaign_id, "GET");
				$html = $this->template_model->get_template($template);
				$apiData = array("html"=>$html);
				$setConent=$this->mailchimp->campaign_content($campaign_id, "PUT", $apiData);
				if($setConent['status']==200){
					$testStatus = true;
				}

				if($testStatus){
					$testEmails = array(
						"test_emails" => array( $email ),
						"send_type" => "html"
					);
				
					$status = $this->mailchimp->test($campaign_id, $testEmails);
					print_r($status);
					if($status['status'] == 204){
						return array('status'=>200, 'message'=>'Test email sent');
					}else{
						$message = ($status['detail']) ? $status['detail'] : $status['response'];
						return array('status'=>$status['status'], 'message'=>$message);
					}
				}else{
					return array('status'=>400, 'Error in setting campaign content');
				}
			}else{
				return array('status'=>400, 'No campaign found with '.$campaign_id.' id');
			}
		}else{
			return array('status'=>400, 'Please enter valid email address');
		}
	}
	
	public function send($campaign_id, $template){
		//$campaign = $this->email_model->get_campaign_db($template);
		if($campaign_id != '' && $template != ''){
			$html = ""; $testStatus = false;
			
			$html = $this->template_model->get_template($template);
			$apiData = array("html"=>$html);
			$setConent=$this->mailchimp->campaign_content($campaign_id, "PUT", $apiData);
			if($setConent['status']==200){
				$testStatus = true;
			}

			if($testStatus){
				$status = $this->mailchimp->send($campaign_id);
				print_r($status);
				if($status['status'] == 204){
					return array("status"=>200, "message" => "Campaign email sent");
				}else{
					return array("status"=>$status['status'], "message" => $status['detail']);
				}
			}else{
				return array("status"=>$setConent['status'], "message" => $setConent['detail']);
			}
		}
		else{
			return array("status"=>404, "message" => 'No campaign found with '.$campaign_id.' id');
		}
	}
	
}
