<?php 

class Mailchimp
{
	
	private $_api_key = '4cd654ce0eb78198cf480b8f0fe09dc1-us14';
	private $_api_endpoint;
	public $folder_id;
	
	function __construct()
	{
		/*PHP CURL & JSON is required*/
		if (!function_exists('curl_init') || !function_exists('json_decode')) {
			throw new Exception('Required CURL & JSON PHP extension.');
		}
		
		$api_prefix = substr($this->_api_key,strpos($this->_api_key,'-')+1);
		$this->_api_endpoint = 'https://' . $api_prefix . '.api.mailchimp.com/3.0/';
	}
	
	public function get_json_headers(){
		return array(
			"HTTP/1.1",
			"Content-type: application/json",
			"Accept: application/json",
			"Authorization: user ". $this->_api_key
		);
	}
	
	public function call($method, $args=array())
	{
		return $this->_raw_request($method, $args);
	}
	
	public function create_list($listdata){
		return $this->_raw_request('lists', 'POST', $listdata);
	}
	
	public function batch_subscribe_list($list_id, $listdata){
		return $this->_raw_request('lists/'.$list_id, 'POST', $listdata);
	}

	public function get_campaigns($campaign, $folder_id = null){
		$found = null;
		$campaigns = $this->_raw_request('campaigns?folder_id='.$folder_id, 'GET');
		/*echo "<pre>";
		print_r($campaigns);
		die;*/
		if($campaigns['status'] == 200){
			foreach($campaigns['response']['campaigns'] as $folder){
				if(isset($folder['name']) && $folder['name'] == $campaign){
					$found = $folder;
					$this->folder_id = $found['id']; 
				}
			}
		}
		return $found;
	}

	public function create_new_campaign($data){
		return $this->_raw_request('campaigns', 'POST', $data);
	}

	public function update_campaign($c_id, $data){
		return $this->_raw_request('campaigns/'.$c_id, 'PATCH', $data);
	}
	
	public function create_merge_field($list_id, $data = array("fname"=>"FNAME", "type"=>"text")){
		return $this->_raw_request('lists/'. $list_id .'/merge-fields', 'POST', $data);
	}
	
	public function batches($operation_list){
		return $this->_raw_request('batches', 'POST', $operation_list);
	}
	
	public function get_status_batches($batch_id){
		return $this->_raw_request('batches/'.$batch_id, 'GET');
	}
	
	public function add_members($list_id, $data){
		return $this->_raw_request('lists/'. $list_id .'/members', 'POST', $data);
	}
	
	public function campaign_content($c_id, $method, $html = ""){
		if($method == "GET"){
			return $this->_raw_request('campaigns/'. $c_id .'/content', 'GET');
		}else if($method == "PUT" && $html){
			return $this->_raw_request('campaigns/'. $c_id .'/content', 'PUT', $html);
		}
	}
	
	public function test($campaign_id, $data){
		return $this->_raw_request('campaigns/'. $campaign_id .'/actions/test', 'POST', $data);
	}
	
	public function send($campaign_id){
		return $this->_raw_request('campaigns/'. $campaign_id .'/actions/send', 'POST');
	}
	
	public function get_folders($_folder)
	{
		$found = null;
		$folders = $this->_raw_request('campaign-folders', 'GET');
		if($folders['status'] == 200){
			foreach($folders['response']['folders'] as $folder){
				if(isset($folder['name']) && $folder['name'] == $_folder){
					$found = $folder;
					$this->folder_id = $found['id']; 
				}
			}
		}
		return $found;
	}
	
	public function create_campaign_folder($data)
	{
		return $this->_raw_request('campaign-folders', 'POST', $data);
	}
	
	public function get_lists()
	{
		return $this->_raw_request('lists', 'GET');
	}
	
	public function delete_list($listid)
	{
		return $this->_raw_request('lists/'.$listid, 'DELETE');
	}
	
	public function get_campaign_report($cid)
	{
		return $this->_raw_request('reports/'.$cid, 'GET');
	}
	
	public function jsonDecode($reply){
		if (defined("JSON_C_VERSION") || version_compare(PHP_VERSION, '5.4.0', '<')) {
			return json_decode($reply, true, 512);
		} else {
			return  json_decode($reply, true, 512, JSON_BIGINT_AS_STRING);
		}
	}
	
	public function isJson ($string) {
	    $isJson = 0;
	    $decodedString = json_decode($string);
	    if (is_array($decodedString) || is_object($decodedString)) {
	        $isJson = 1;    
	    }
	    return $isJson;
	}
	
	private function _raw_request($method, $requestType = 'GET', $postData = array())
	{
		$url = $this->_api_endpoint. $method;
		$return = array();
		
		/* echo "URL = ".$url;
		echo "<br/>".json_encode($postData);
		echo "<br/>".$requestType;
		die(); */
		
	    $ch = curl_init();
	    curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false); 
	    curl_setopt($ch, CURLOPT_URL, $url);
	    curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
	
	    
	    if ($requestType == 'POST') {
	        curl_setopt($ch, CURLOPT_POST, 1);
	        curl_setopt($ch, CURLOPT_POSTFIELDS, json_encode($postData));  
	    }
		if($requestType == 'PUT'){
			curl_setopt($ch, CURLOPT_CUSTOMREQUEST, "PUT");
			curl_setopt($ch, CURLOPT_POSTFIELDS, json_encode($postData));
		}
		if($requestType == 'PATCH'){
			curl_setopt($ch, CURLOPT_CUSTOMREQUEST, "PATCH");
			curl_setopt($ch, CURLOPT_POSTFIELDS, json_encode($postData));
		}
		if($requestType == 'DELETE'){
			curl_setopt($ch, CURLOPT_CUSTOMREQUEST, "DELETE");
		}

	    curl_setopt($ch, CURLOPT_HTTPHEADER, $this->get_json_headers()); 
	    $data = curl_exec($ch);
		/*print_r($data);*/ 
	    $validResponseCodes = array(200, 201, 202, 204, 400, 403, 404, 405, 409);
	    $responseCode = curl_getinfo($ch, CURLINFO_HTTP_CODE); 

	    if (curl_errno($ch)) {
	    	$curl_error = curl_error($ch);
			$return['status'] = $responseCode;
			$return['response'] = $curl_error;
	    }else{
			if ($this->isJson($data)) {
	            $data = $this->jsonDecode($data);
				$return['status'] = $responseCode;
				$return['response'] = $data;
	        }else{
				$return['status'] = $responseCode;
				$return['response'] = $data;			
			}
		}
		curl_close($ch);
	    return $return;
	}
}