<?php
session_start();
require_once ("includes/db.inc.php");
require_once ("includes/authenticate.inc.php");
require_once ("includes/funzioni.inc.php"); 
require_once ("includes/pagination.class.php");

// connessione database, forzatura del charset
$connessione = mysqli_connect(DB_HOSTNAME, DB_USERNAME, DB_PASSWORD, DB_DATABASE);

mysqli_set_charset($connessione,"utf8");

sessionAuthenticate(HTTP_SERVER);


$sql = "SELECT u.*, CONCAT(last_name,' ', first_name) as utente  FROM wcrs_users u WHERE 1";
		
if(!empty($_GET['filtro_utente'])){
	$sql .= " AND LCASE(CONCAT(last_name, ' ', first_name)) LIKE '%" . mysqli_real_escape_string($connessione,strtolower($_GET['filtro_utente'])) . "%'";
}

if(!empty($_GET['filtro_email'])){
	$sql .= " AND LCASE(email) LIKE '%" . mysqli_real_escape_string($connessione,strtolower($_GET['filtro_email'])) . "%'";
}

if(isset($_GET['filtro_status']) && $_GET['filtro_status'] != "-1"){
	$sql .= " AND active = '".$_GET['filtro_status']."'";
}	

if(!empty($_GET['filtro_expire'])){
	$sql .= " AND pay_expire <= DATE_SUB(NOW(), INTERVAL 10 DAY)";
}

if(!empty($_GET['filtro_regdate_from'])){
	$sql .= " AND date_registration  >= '". mysqli_real_escape_string($connessione,Date('Y-m-d', strtotime($_GET['filtro_regdate_from'])))."'";
}

if(!empty($_GET['filtro_regdate_to'])){
	$sql .= " AND date_registration  <= '". mysqli_real_escape_string($connessione,Date('Y-m-d', strtotime($_GET['filtro_regdate_to'])))."'";
}

if(!empty($_GET['filtro_paiddate_from'])){
	$sql .= " AND DATE_FORMAT(STR_TO_DATE(pay_date, '%H:%i:%s %M %d, %Y'), '%Y-%m-%d') >= ".mysqli_real_escape_string($connessione,$_GET['filtro_paiddate_from']);
}

if(!empty($_GET['filtro_paiddate_to'])){
	$sql .= " AND DATE_FORMAT(STR_TO_DATE(pay_date, '%H:%i:%s %M %d, %Y'), '%Y-%m-%d') <= ".mysqli_real_escape_string($connessione,$_GET['filtro_paiddate_to']);
}

if(!empty($_GET['filtro_expdate_from'])){
	$sql .= " AND pay_expire >= ".mysqli_real_escape_string($connessione,$_GET['filtro_expdate_from']);
}

if(!empty($_GET['filtro_expdate_to'])){
	$sql .= " AND pay_expire >= ".mysqli_real_escape_string($connessione,$_GET['filtro_expdate_to']);
}

if(!empty($_GET['filtro_level'])){
	$sql .= " AND level = ".mysqli_real_escape_string($connessione,$_GET['filtro_level']);
}

if(isset($_GET['filtro_payfr']) && $_GET['filtro_payfr'] != "-1"){
	$sql .= " AND pay_frequency = '".mysqli_real_escape_string($connessione,$_GET['filtro_payfr'])."'";
}


$sort_data = array(
	'id',
	'last_name'
);

if (isset($sort) && in_array($sort, $sort_data)) {
	$sql .= " ORDER BY " . $sort;
} else {
	$sql .= " ORDER BY id";
}

if (isset($order) && ($order == 'DESC')) {
	$sql .= " DESC";
} else {
	$sql .= " ASC";
}	

$result = mysqli_query($connessione,$sql) or die(mysqli_error());
if(mysqli_num_rows($result) >0){
	
	$file_ending = "xls";
	$filename = Date('YmdHis');
	header("Content-Type: application/xls");    
	header("Content-Disposition: attachment; filename=$filename.xls");  
	header("Pragma: no-cache"); 
	header("Expires: 0");
	
	$sep = "\t"; //tabbed character
	$headers = array('User', 'Email', 'Address', 'Phone', 'Date reg.', 'Level', 'Life', 'Paid Date', 'Active', 'Sub. Id', 'Pay Fr', 'Expiry Date');
	for ($i = 0; $i < count($headers); $i++) {
		echo $headers[$i] . "\t";
	}
	print("\n"); 
	
	while($row = mysqli_fetch_array($result)){
					
		$pay_frequency = $row['pay_frequency'];
		$giorni = "+40 days";
		if(!empty($pay_frequency)){
			if($pay_frequency == "1 M"){
				$giorni = "+40 days";
			}elseif($pay_frequency == "2 M"){
				$giorni = "+70 days";
			}elseif($pay_frequency == "3 M"){
				$giorni = "+100 days";
			}
		}
		// calcolo la prossima data di scadenza
		if(!empty($row['pay_date'])){
			$pay_date_time = strtotime($row['pay_date']);
			$pay_next_datetime = date("Y-m-d", strtotime($giorni, $pay_date_time));			
		}else{
			$pay_next_datetime="";
		}
			
        $schema_insert = "";
        /*for($j=0; $j<mysql_num_fields($result);$j++)
        {
             if(!isset($row[$j]))
                $schema_insert .= "NULL".$sep;
            elseif ($row[$j] != "")
                $schema_insert .= "$row[$j]".$sep;
            else
                $schema_insert .= "".$sep; */
			
			$schema_insert .= $row['utente'].$sep;
			$schema_insert .= $row['email'].$sep;
			$schema_insert .= $row['address_street'].','.$row['address_street2'].','.$row['address_city'].','.$row['address_state'].','.$row['address_country'].','.$row['address_zip'].$sep;
			$schema_insert .= $row['contact_no'].$sep;
			$schema_insert .= $row['date_registration'].$sep;
			
			$level = '';
			
			if($row['level']==1) $level = 'Standard membership';
			if($row['level']==2) $level = 'Premium membership';
			if($row['level']==5) $level = 'Free membership';
			if($row['level']==3) $level = 'Trade membership';
			
			$schema_insert .= $level.$sep;
			
			$life = ($row['life_member']) ? 'YES' : 'NO';
			$schema_insert .= $life.$sep;
			
			$schema_insert .= $row['pay_date'].$sep;
			
			$active = ($row['active']) ? 'Active' : 'Not Active';
			$schema_insert .= $active.$sep;
			
			$schema_insert .= $row['subscr_id'].$sep;
			$schema_insert .= $row['pay_frequency'].$sep;
			$schema_insert .= $pay_next_datetime.$sep;
       // }
        $schema_insert = str_replace($sep."$", "", $schema_insert);
        $schema_insert = preg_replace("/\r\n|\n\r|\n|\r/", " ", $schema_insert);
        $schema_insert .= "\t";
        print(trim($schema_insert));
        print "\n";
    }  
	
}
		
?>	