<?php

class StripeService{

    private $db;

    function __construct()
    {
        session_start();
        require_once '../Connections/rounds4sale.php';
        require './stripe.config.php';
        require './autoload.php';
        
        //$this->dbConnect($hostname_cleaningrounds, $username_cleaningrounds, $password_cleaningrounds, $database_cleaningrounds);
		
		$this->db = $cleaningrounds;
    }

    function dbConnect($hostname_cleaningrounds, $username_cleaningrounds, $password_cleaningrounds, $database_cleaningrounds){
        $this->db = mysqli_connect($hostname_cleaningrounds, $username_cleaningrounds, $password_cleaningrounds, $database_cleaningrounds);
        mysqli_set_charset($this->db,"utf8");
    }

    function select_row($sql){
        $data = array();
        if($sql){
            $result = mysqli_query($this->db, $sql);
            while($row = mysqli_fetch_assoc($result)){
                $data[] = $row;
            }
        }
        return $data;
    }

    function insertCustomer($customer){
        $c_id = $customer['id'];
        $c_email = $customer['email'];
        //mysqli_query($this->db, "INSERT INTO tbl_stripe_subscriptions(cust_id) VALUES('".$customer['id']."')");

        /*update the wcrs_users table*/
        mysqli_query($this->db, "UPDATE wcrs_users set cust_id='$c_id' WHERE email='$c_email'") or die(mysqli_error($this->db));
    }

    function insertSubscription($subscription){
        $s_id = $subscription['id'];
        $c_id = $subscription['customer'];
        $current_period_start = Date('Y-m-d H:i:s', $subscription['current_period_start']);
        $current_period_end = Date('Y-m-d H:i:s', $subscription['current_period_end']);
        $status = $subscription['status'];
        $created = Date('Y-m-d H:i:s', $subscription['created']);
        $collection_method = $subscription['collection_method'];
        $currency = $subscription['currency'];
        $default_payment_method = $subscription['default_payment_method'];
        
        /* insert the subscription information in seperate table */
        mysqli_query($this->db, "INSERT INTO tbl_stripe_subscriptions(`cust_id`, `subscr_id`, `current_period_start`, `current_period_end`, `subscription_status`, `subscription_created_date`, `collection_method`, `currency`, `default_payment_method`) VALUES('$c_id','$s_id','$current_period_start','$current_period_end','$status','$created','$collection_method','$currency', '$default_payment_method')") or die(mysqli_error($this->db));

        /*update the wcrs_users table*/
        $payStatus = 'incomplete';
        if($status=='active'){
            $payStatus = 'paid';
        }

        $subscr_date =  Date('H:i:s M d, Y')." PDT";
        $intervalDays = "+30 Days";
        $subscr_end_date = Date('Y-m-d', strtotime($intervalDays));

        mysqli_query($this->db, "UPDATE wcrs_users SET pay_status='$payStatus', subscr_id='$s_id', subscr_date='$subscr_date', pay_date='$subscr_date', pay_frequency='1 M',  pay_expire='$subscr_end_date' WHERE cust_id = '$c_id'")  or die(mysqli_error($this->db));
    }

    function updateSubscription($subscription){
        $s_id = $subscription['id'];
        $c_id = $subscription['customer'];
        $current_period_start = Date('Y-m-d H:i:s', $subscription['current_period_start']);
        $current_period_end = Date('Y-m-d H:i:s', $subscription['current_period_end']);
        $status = $subscription['status'];
        $collection_method = $subscription['collection_method'];
        $currency = $subscription['currency'];
        $default_payment_method = $subscription['default_payment_method'];
        
        /* update the subscription information of seperate table */
        mysqli_query($this->db, "UPDATE tbl_stripe_subscriptions SET current_period_start='$current_period_start', current_period_end='$current_period_end', subscription_status='$status', collection_method='$collection_method', currency='$currency', default_payment_method='$default_payment_method' WHERE subscr_id='$s_id' AND cust_id='$c_id'") or die(mysqli_error($this->db));

        /*update the wcrs_users table*/
        $payStatus = 'incomplete';
        if($status=='active'){
            $payStatus = 'paid';
        }

        $subscr_date =  Date('H:i:s M d, Y')." PDT";
        //$intervalDays = "+30 Days";
        $subscr_end_date = Date('Y-m-d', $subscription['current_period_end']);

        mysqli_query($this->db, "UPDATE wcrs_users SET pay_status='$payStatus', subscr_id='$s_id', subscr_date='$subscr_date', pay_date='$subscr_date', pay_frequency='1 M',  pay_expire='$subscr_end_date' WHERE cust_id = '$c_id'") or die(mysqli_error($this->db));
    }

    function cancelSubscription($subscription){
        $s_id = $subscription['id'];
        $c_id = $subscription['customer'];
        $status = $subscription['status'];

        /* update the subscription information of seperate table */
        mysqli_query($this->db, "UPDATE tbl_stripe_subscriptions SET subscription_status='$status' WHERE subscr_id='$s_id' AND cust_id='$c_id'") or die(mysqli_error($this->db));

        /*update the wcrs_users table*/
        mysqli_query($this->db, "UPDATE wcrs_users SET level='5', pay_status='canceled', subscr_id='' WHERE subscr_id='$s_id' AND cust_id='$c_id'") or die(mysqli_error($this->db));
    }

    function invoiceCreated($invoice){
        $invoide_id = $invoice['id'];
        $subscription_id = $invoice['subscription'];
        $invoice_number = $invoice['number'];
        $customer_id = $invoice['customer'];
        $billing_email = $invoice['customer_email'];
        $currency = $invoice['currency'];
        $invoice_status = $invoice['status'];
        $invoice_created_date = date("Y-m-d H:i:s",$invoice['created']);
        $last_finalization_error = $invoice['last_finalization_error'];
        
        /*insert the newly created invoice data*/
        mysqli_query($this->db, "INSERT INTO `tbl_stripe_invoices`(`invoice_id`, `subscription_id`, `invoice_number`, `customer_id`, `billing_email`, `currency`, `invoice_status`, `invoice_created_date`, `last_finalization_error`) VALUES ('$invoide_id','$subscription_id','$invoice_number','$customer_id','$billing_email','$currency','$invoice_status','$invoice_created_date','$last_finalization_error')") or die(mysqli_error($this->db));
    }

    function invoiceFinalized($invoice){
        $id = $invoice['id'];
        $invoice_finalized_date = date("Y-m-d H:i:s",$invoice['finalized_at']);
        $invoice_status = $invoice['status'];
        $last_finalization_error = $invoice['last_finalization_error'];

        /*update the invoice status*/
        mysqli_query($this->db, "UPDATE `tbl_stripe_invoices` SET invoice_finalized_date='$invoice_finalized_date', invoice_status='$invoice_status', last_finalization_error='$last_finalization_error' WHERE invoice_id='$id'") or die(mysqli_error($this->db));
    }

    function updateInvoiceStatus($invoice){
        $id = $invoice['id'];
        $invoice_status = $invoice['status'];
        $last_finalization_error = $invoice['last_finalization_error'];
         
        /*update the invoice status*/
        mysqli_query($this->db, "UPDATE `tbl_stripe_invoices` SET invoice_status='$invoice_status', last_finalization_error='$last_finalization_error' WHERE invoice_id='$id'") or die(mysqli_error($this->db));
    }

    function invoicePaymentSuccess($invoice){
        $subscription_id = $invoice['subscription'];
        $customer_id = $invoice['customer'];

        /*update the wcrs_users table*/
        mysqli_query($this->db, "UPDATE wcrs_users SET active='1', pay_status='paid', subscr_id='$subscription_id' WHERE cust_id='$customer_id'") or die(mysqli_error($this->db));

        /* get the updated stripe subscription */
        require './stripe.config.php';
        require './autoload.php';
        $stripe = new \Stripe\StripeClient(STRIPE_KEY);
        $subscription = $stripe->subscriptions->retrieve($subscription_id);
        $this->updateSubscription($subscription);
    }

    function paymentFailedNotification($invoice){
        $invoide_id = $invoice['id'];
        $subscription_id = $invoice['subscription'];
        $customer = $this->select_row("SELECT * FROM wcrs_users WHERE cust_id='$invoide_id' AND subscr_id='$subscription_id'");

        $invoiceURL = $invoice['hosted_invoice_url'];

        $subject = "Window Cleaning Rounds For Sale";				
		$from = "From: info@windowcleaningroundforsale.co.uk" . "\r\n";	

        $body = '<div style="margin:auto;width:600px;border:1px solid #cccccc; padding:10px;font-family: Arial, Calibri, sans-serif;"><p>Dear '.$customer['first_name'].' '.$customer['last_name'].'</p><br>'.
        '<p>Unfortunately your subscription payment failed this month.</p><br>'.        '<p>Re-authorise your payment here <a style="background:#0277bd;color:white;padding:6px 15px;font-size:18px;font-family: Arial, Calibri, sans-serif;text-decoration:none;font-weight:bold;" href="'.$invoiceURL.'">Pay Now</a></p><br>'.
        '<p>You are missing out on great window cleaning rounds!</p><br>'.
        '<p>Stay up-to-date on:<br>'.
        '<p>How much your own round is worth? What are your competitors selling? What is the average price for domestic or commercial work in your area?</p>'.        
        '<p>Keep your finger on the pulse by signing up today!</p>'.
        '<p>Re-authorise your payment here <a style="background:#0277bd;color:white;padding:6px 15px;font-size:18px;font-family: Arial, Calibri, sans-serif;text-decoration:none;font-weight:bold;" href="'.$invoiceURL.'">Pay Now</a></p></div>';
		@mail($customer[0]['email'], $subject, $body, $from);
    }

    function getStripeSubscription($subscription_id){
        /* get the updated stripe subscription */
        require './stripe.config.php';
        require './autoload.php';
        $stripe = new \Stripe\StripeClient(STRIPE_KEY);
        $subscription = $stripe->subscriptions->retrieve($subscription_id);
        //$this->updateSubscription($subscription);
        return $subscription;
    }

}


?>