<?php 
setlocale(LC_MONETARY, 'en_GB');
session_start();
require_once('Connections/rounds4sale.php');
require_once("includes/pagination.class.php");

$connessione = mysqli_connect($hostname_cleaningrounds, $username_cleaningrounds, $password_cleaningrounds, $database_cleaningrounds);
mysqli_set_charset($connessione,"utf8");

$rounds_table = "rounds_wanted";
$wanted = "true"; 
$titolo = "Window cleaning rounds wanted";

$record_per_pagina = 20;

if (isset($_GET['sort'])) {
	$sort = $_GET['sort'];
} else {
	$sort = 'date_insert';
}

if (isset($_GET['order'])) {
	$order = $_GET['order'];
} else {
	$order = 'DESC';
}

if (isset($_GET['page'])) {
	$page = $_GET['page'];
} else {
	$page = 1;
}

$url = '';

if (isset($_GET['location_display'])) {
	$url .= '&location_display=' . urlencode(html_entity_decode($_GET['location_display'], ENT_QUOTES, 'UTF-8'));
}

if (isset($_GET['search_location'])) {
	$url .= '&search_location=' . urlencode(html_entity_decode($_GET['search_location'], ENT_QUOTES, 'UTF-8'));
}

if (isset($_GET['filter_price'])) {
	$url .= '&filter_price=' . urlencode(html_entity_decode($_GET['filter_price'], ENT_QUOTES, 'UTF-8'));
}

if ($order == 'ASC') {
	$url .= '&order=DESC';
} else {
	$url .= '&order=ASC';
}
		
if (isset($_GET['page'])) {
	$url .= '&page=' . $_GET['page'];
}

$sql = "SELECT COUNT(*) AS totale FROM rounds_wanted t LEFT JOIN country c ON (t.id_country=c.id_country) WHERE (status = 'live' OR status = 'sold')";
								
if(!empty($_GET['location_display'])){
	$sql .= " AND t.id_country = '" . (int)$_GET['location_display']."' ";
}
								
if(!empty($_GET['search_location'])){
	$sql .= "AND (c.name LIKE '%" . mysqli_real_escape_string($connessione,$_GET['search_location'])."%' OR comments LIKE '%" . mysqli_real_escape_string($connessione,$_GET['search_location'])."%')";
}	

if(!empty($_GET['county_display'])){
	$sql .= " AND t.county_id = '" . $_GET['county_display']."' ";
}
								
if(!empty($_GET['filter_price']) && $_GET['filter_price'] != 'Show All'){	
	if(strpos($_GET['filter_price'], "+") !== false){
		$sql .= " AND price > '".ltrim($_GET['filter_price'], '+')."'";
	}else{
		$sql .= " AND price <= '".$_GET['filter_price']."'";
	}			
}
								
$result = mysqli_query($connessione,$sql) or die(mysqli_error($connessione));
$row = mysqli_fetch_array($result);
$totale = $row['totale'];

$loc_query_county       = "SELECT * FROM tbl_county where 1 order by county_group_priority ASC";
$loc_exe_query_county   = mysqli_query($connessione,$loc_query_county);
?>
<!DOCTYPE html>
<html lang="it">
<head>
<meta charset="utf-8">
<meta http-equiv="X-UA-Compatible" content="IE=edge">
<meta name="viewport" content="width=device-width, initial-scale=1">
<title>Window Cleaning Round For Sale</title>
<meta name="Description" content="Find a window cleaning business for sale. Advertise your window cleaning business for sale. Look for a window cleaning round.">
<meta name="Keywords" content="window cleaning business, window cleaning rounds for sale, window cleaning rounds wanted, window cleaning business for sale, window cleaning round for sale">
<!--<link rel="STYLESHEET" type="text/css" href="http://www.windowcleaningresources.co.uk/wcr.css" />-->
<link href="assets/css/bootstrap.min.css" rel="stylesheet">
<link rel="stylesheet" href="https://use.fontawesome.com/releases/v5.3.1/css/all.css" integrity="sha384-mzrmE5qonljUremFsqc01SB46JvROS7bZs3IO2EmfFsd15uHvIt+Y8vEf7N7fWAU" crossorigin="anonymous">
 <link href="assets/css/style.css" rel="stylesheet">
<link href="https://fonts.googleapis.com/css?family=Open+Sans" rel="stylesheet">

<script src="https://ajax.googleapis.com/ajax/libs/jquery/1.11.3/jquery.min.js"></script>
<script src="assets/js/bootstrap.min.js"></script>
<script type="text/javascript" src="./index.js"></script>
<script>
var text1="Advertise your window cleaning round for sale for free with www.windowcleaningresources.co.uk"
comeback=0
cometo=0
function dis(){
window.status=text1.substring(0,cometo)
if(comeback==1){
cometo--;
if(cometo==0){comeback=0}
} else {cometo++;if(cometo==text1.length){comeback=1}}
window.status=text1.substring(0,cometo)+"|"
if(cometo==text1.length){window.setTimeout("dis()",500);} else {window.setTimeout("dis()",75);}
}
dis()
</script>
</head>
<body>
<div id="wrapper">
	<?php require_once("includes/header.php");?>
	<?php require_once("includes/subheader.php");?>
	<div class="main-container">
		<div class="container">
			<div class="row">
				<div class="col-md-9 page-content">
					<div class="content-box col-xl-12">
						<div class="row row-featured row-featured-category">
							<div class="col-xl-12  box-title no-border">
                                <div class="inner">
									<h2 class="text-center">Wanted (<?php echo $totale;?>)</h2>
                                </div>
                            </div>
						</div>	
						<div class="row">
							<div class="col-xl-12">
								<div class="card">
									<div class="card-header">Search</div>
									<div class="card-body">
										<form method="get" action="wanted.php?filter=1">
											<div class="row">
												<div class="col-sm-5">
													<div class="form-group">
														<label for="location_display" class="sr-only">Region</label>
														<?php /*?><select name="location_display" class="form-control">
															<option value="">Select Region</option> 															
															<?php 
															$query_cat = mysqli_query($connessione,"SELECT * FROM country ORDER BY postcode_required DESC, id_country ASC");
															while($row_cat = mysqli_fetch_array($query_cat)) { 
															?>     
															<option <?php if ($row_cat['id_country'] == $_GET['location_display']) echo 'selected="selected"';?> value="<?php echo $row_cat['id_country']; ?>"><?php echo $row_cat['name']; ?></option> 
															<?php } ?>                                              
														</select><?php */?>

														<select name="county_display" class="form-control">
												       <option value="">Select Region</option>
												       <?php
												       $loc_prev_county_group = '';
												       
									while($row =mysqli_fetch_array($loc_exe_query_county)){
									    $loc_curr_county_group = $row['county_group'];
									    if($loc_prev_county_group != $loc_curr_county_group) {
									        if($loc_prev_county_group != '') {
									            echo '</optgroup>';
									        }
									        echo '<optgroup label="'.$loc_curr_county_group.'">';
									    }
									
									    $loc_prev_county_group = $loc_curr_county_group;
									?>
									    <option value="<?php echo $row['county_id'] ?>" <?php if ($_GET['county_display'] == $row['county_id'] ) echo 'selected';?>><?php echo $row['county_name'] ?></option>
								<?php	}
								echo '</optgroup>';
												       ?>
														</select>


													</div>
											  </div>
											  <div class="col-sm-5">
												  <div class="form-group">
													<label for="search_location" class="sr-only">Keywords</label>
													<input type="text" class="form-control" name="search_location" value="<?php echo $_GET['search_location'];?>" placeholder="Keywords">
												  </div>
											  </div>
											  <div class="col-sm-2">
												<button type="submit" class="btn btn-primary btn-lg btn-block">Filter</button>
											  </div>
											</div>
										</form>
									</div>
								</div>
							</div>
						</div>
						<div class="row">
							<div class="col-xl-12">
								<div class="adds-wrapper jobs-list">
								<?php
								// $sql = "SELECT t.*, c.name AS location FROM rounds_wanted t LEFT JOIN country c ON (t.id_country=c.id_country) WHERE (status = 'live' OR status = 'sold')";
								$sql = "SELECT t.*, c.name AS location, ct.county_name FROM rounds_wanted t 
								LEFT JOIN tbl_county ct  on t.county_id = ct.county_id
								LEFT JOIN country c ON (t.id_country=c.id_country) WHERE (status = 'live' OR status = 'sold')";
								
								if(!empty($_GET['location_display'])){
									$sql .= " AND t.id_country = '" . $_GET['location_display']."' ";
								}
								
								if(!empty($_GET['search_location'])){
									$sql .= "AND (c.name LIKE '%" . $_GET['search_location']."%' OR comments LIKE '%" . $_GET['search_location']."%')";
								}		
								
								if(!empty($_GET['county_display'])){
									$sql .= " AND t.county_id = '" . $_GET['county_display']."' ";
								}
				
								$sort_data = array(
									'id',
									'date_insert',
								);

								if (isset($sort) && in_array($sort, $sort_data)) {
									$sql .= " ORDER BY " . $sort;
								} else {
									$sql .= " ORDER BY id";
								}

								if (isset($order) && ($order == 'DESC')) {
									$sql .= " DESC";
								} else {
									$sql .= " ASC";
								}	
								
								$sql .= " LIMIT " . (int)($page-1)*$record_per_pagina . "," . (int)$record_per_pagina;			
								$result = mysqli_query($connessione,$sql) or die(mysqli_error($connessione));

								if(mysqli_num_rows($result) >0){
									while($row_showAds = mysqli_fetch_array($result)){	 
									   // Is this a trade advert?
									   $trade = $row_showAds['trade'];
									   
									   if($trade == "1")
									   {
										   $postedBy = " by a Trade Member";
										   $adClass = "tradeAdvertResulBox"; 
									   }
									   else
									   {
										   $postedBy = "";
										   $adClass = "advertResulBox";
									   }
	 
								?>
     
		<div class="item-list job-item">
			<strong><span class="style28">Posted on <?php echo $row_showAds['date']; echo $postedBy; ?></span><br />
			Region:</strong> <?php echo $row_showAds['county_name']; ?><br /> 
			<strong>Location:</strong> <?php echo $row_showAds['covering']; ?><br />
		

            <div class="style25" scope="row"><div align="left"><strong>Comments: </strong><span class="style27"><?php echo $row_showAds['comments']; ?></span></div></div>
		<span class="style25">

        <?php 
			
		if($wanted == "false")
		{ 
		    $status = $row_showAds['status'];
			
			if($status == "sold")
			{
			    $price = "SOLD"; 
			}
			else
			{
			    $price = str_replace('GBP','&pound;',money_format('%i', $row_showAds['price']));		
			}
		    
		?>
        <strong>Asking Price :</strong> <?php echo $price; ?><br />
        <?php } ?>
        
            
        <?php
		// only reveal contact details to members UNLESS it's a trade advert
		if($_SESSION['session_level'] == 5){
		?>
		<a href="user_settings.php" style="color:#0033FF"><b>Upgrade your membership to see contact details</b></a><br>  
		<?php }elseif($_SESSION['session_level'] > 0 || $trade == "1"){ ?>
		<strong>Contact Details :</strong> <?php echo $row_showAds['name']; ?> - 
		<?php echo $row_showAds['telephone1']; 
		      if(!empty($row_showAds['telephone2']))
			  {
			      echo " or " . $row_showAds['telephone2'];
			  }?>  - <a href="mailto:<?php echo $row_showAds['email']; ?>?subject=WCR site - Advert Enquiry">[Send Email] </a></span>
        
        <?php }else{ ?>
			<a href="register_form.php" style="color:#0033FF"><b>Register as a member to view contact details</b></a><br>  
         <?php 	} 	?>
        
	</div>
    <?php 
	} 
	}else{
		echo '<h1>No result found!</h1>';
	}		
	?>
     
     
			<?php	
			$url = preg_replace("/&page=\d+/", '', $_SERVER['REQUEST_URI']) ;
            $cp = new CreativePager();
            $parametri['selected_page'] = $page;
            $parametri['total_items']	= $totale;
            $parametri['items_per_page'] = $record_per_pagina;
            $parametri['url'] = $url;
            $parametri['nav_pages'] = 10;
            $parametri['info1'] = false;
            $parametri['info2'] = false;
            $parametri['first'] = 'Prev';
            $parametri['last']	= 'Next';
            $cp->pager($parametri);
            echo utf8_encode($cp->display());
            ?>  
  
						</div> 
							</div> 
						</div>
					</div>
				</div>
  
				<div class="col-md-3 page-sidebar">
					<?php require_once('incLeftMenu.php'); ?>
				</div>
                
			</div>
		</div>
	</div>
 
	<?php //require("footer.php"); ?>
	<div id="sub-footer">
		<div class="container">
			<div class="row">
				<div class="col-md-12 col-sm-12 col-xs-12 text-center">
					<h3>Window Cleaning Resources - All you need to succeed</h3>
					<p>www.windowcleaningroundforsale.co.uk is regularly visited by thousands of window cleaners each month.
					If you are a supplier to the trade and would like to advertise your company on this site please <a href="http://www.windowcleaningresources.co.uk/contact-us/pay-advertising/">contact us</a>.</p>		
					<img src="https://www.windowcleaningrounds.co.uk/wp-content/uploads/2018/05/windowcleaningroundforsale.png" class="img-fluid">				
				</div>
			</div>
		</div>
	</div>
    <?php require_once("includes/footer.php");?>
</div>	
</body>
</html>